--every single command here
rawset(_G, "cv_s3musicversion", CV_RegisterVar({
	name = "s3_musicversion",
	defaultvalue = "Final",
	flags = CV_SAVE,
	PossibleValue = {Final = 1, Prototype = 2},
}))

rawset(_G, "cv_s3music", CV_RegisterVar({
	name = "s3_music",
	defaultvalue = "On",
	flags = CV_SAVE,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_s3choppy", CV_RegisterVar({
	name = "s3_choppy",
	defaultvalue = "Off",
	flags = CV_SAVE,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_s3camera", CV_RegisterVar({
	name = "s3_camera",
	defaultvalue = "Movement",
	flags = CV_SAVE,
	PossibleValue = {Off = 0, Movement = 1, Zoom = 2, Both = 3},
}))

rawset(_G, "cv_s3rings", CV_RegisterVar({
	name = "s3_rings",
	defaultvalue = "Off",
	flags = CV_SAVE,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_s3rollangle", CV_RegisterVar({
	name = "s3_rollangle",
	defaultvalue = "Off",
	flags = CV_SAVE,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_s3keeprings", CV_RegisterVar({
	name = "s3_keeprings",
	defaultvalue = "On",
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_s3keepshields", CV_RegisterVar({
	name = "s3_keepshields",
	defaultvalue = "On",
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))

--stuff go in and stuff go out i guess thanks spectra
local function saveCmds(p)
    if consoleplayer ~= p then return end

    local file = io.openlocal("client/s3sonic/s3v1-1commands.dat", "w")

    local consolevars = {cv_s3musicversion.value, cv_s3music.value, cv_s3choppy.value, cv_s3camera.value, cv_s3rings.value, cv_s3rollangle.value}
    for i = 1, #consolevars do
        file:write(consolevars[i].."\n")
    end

    io.close(file)
end

local function loadCmds(p)
    if consoleplayer ~= p then return end

    local file = io.openlocal("client/s3sonic/s3v1-1commands.dat", "r")
    if file
        local r
        local consolevars = {cv_s3musicversion, cv_s3music, cv_s3choppy, cv_s3camera, cv_s3rings, cv_s3rollangle}
        for i = 1, #consolevars do
            r = file:read()
            CV_StealthSet(consolevars[i], r)
        end
    file:close()
    end
end

addHook("PlayerThink", function(p)
    if consoleplayer ~= p then return end
    
    p.s3loadedsettings = $ or 0
    
    if p.s3loadedsettings == 0
        p.s3loadedsettings = 1
        loadCmds(p)
    end
    
    p.s3changemusic = $ or cv_s3music.value
    p.s3changeversion = $ or cv_s3musicversion.value
	p.s3choppy = $ or cv_s3choppy.value
	p.s3camera = $ or cv_s3camera.value
	p.s3rings = $ or cv_s3rings.value
	p.s3rollangle = $ or cv_s3rollangle.value
    
    if (p.s3changemusic ~= cv_s3music.value) 
	or (p.s3changeversion ~= cv_s3musicversion.value) 
	or (p.s3choppy ~= cv_s3choppy.value) 
	or (p.s3camera ~= cv_s3camera.value) 
	or (p.s3rings ~= cv_s3rings.value) 
	or (p.s3rollangle ~= cv_s3rollangle.value) 
        p.s3changemusic = cv_s3music.value
        p.s3changeversion = cv_s3musicversion.value
		p.s3choppy = cv_s3choppy.value
		p.s3camera = cv_s3camera.value
		p.s3rings = cv_s3rings.value
		p.s3rollangle = cv_s3rollangle.value
        saveCmds(p)
    end
end)