freeslot("S_STCROUCH1", "S_STVICT1", "S_STVICT2", "S_STCROUCH2", "S_STLOOK1", "S_STLOOK2", "S_STKICK")
    
freeslot("SPR2_CRCA", "SPR2_CRCB", "SPR2_LOKA", "SPR2_LOKB", "SPR2_KICK", "SPR2_VICT")

states[S_STCROUCH1] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_CRCA,
	tics = 4,
	nextstate = S_STCROUCH2,
}

states[S_STCROUCH2] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_CRCB,
	tics = 4,
	nextstate = S_STCROUCH2,
}

states[S_STVICT1] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_VICT,
	tics = 4,
	nextstate = S_STVICT2,
}

states[S_STVICT2] = {
	sprite = SPR_PLAY,
	frame = B|SPR2_VICT|FF_ANIMATE,
	tics = 16,
	var1 = 3,
	var2 = 4, 
	nextstate = S_STVICT2
}

states[S_STLOOK1] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_LOKA,
	tics = 4,
	nextstate = S_STLOOK2,
}

states[S_STLOOK2] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_LOKB,
	tics = 4,
	nextstate = S_STLOOK2,
}

states[S_STKICK] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_KICK,
	tics = -1,
	nextstate = S_PLAY_FALL,
}

addHook("MobjMoveCollide", function(mo, mo2)
if not (mo.skin == "s3sonic") return end
    if (mo2 and mo2.valid)
        if not (mo.z-FixedMul(36*FRACUNIT, mo.scale) > mo2.z+mo2.height) and not (mo2.z-FixedMul(36*FRACUNIT, mo.scale) > mo.z+mo.height) -- i took this from instashield again
            if (mo2.type == MT_YELLOWSPRING or mo2.type == MT_REDSPRING or mo2.type == MT_BLUESPRING) and (mo.state == S_PLAY_SPRING)
                mo.state = S_PLAY_WALK
                mo.player.stroll = 1
                mo.player.strollang = 0
                mo.rollangle = 0
            end
        end
        if (mo2.type == MT_STEAM) and (mo.z > mo2.z - 20*mo2.scale) and (mo.z < mo2.z + 20*mo2.scale)
            mo.player.steamed = 2
        end
    end
end, MT_PLAYER)

addHook("AbilitySpecial", function(player)
    if (player.mo and player.valid) and (player.mo.skin == "s3sonic")
        if not player.powers[pw_super] and not player.powers[pw_invulnerability] and not player.powers[pw_flashing] and All7Emeralds(emeralds) and (player.rings >= 50) and (player.powers[pw_shield] == SH_NONE or player.powers[pw_shield] == SH_FIREFLOWER)
			P_DoSuperTransformation(player)
            S_StopSoundByID(player.mo, sfx_supert)
            player.charflags = $|SF_SUPER
            return false
        end
    end
end)

addHook("PreThinkFrame", do
    for player in players.iterate
        if (player.mo and player.valid) and (player.mo.skin == "s3sonic")
            if (player.cmd.forwardmove < -20) and (player.mo.flags2 & MF2_TWOD)
                player.cmd.buttons = $|BT_SPIN
            end
            if (player.cmd.forwardmove > 20) and (player.mo.flags2 & MF2_TWOD)
                player.cmd.buttons = $|BT_CUSTOM1
            end
        end
    end
end)

addHook("ThinkFrame", do
    for player in players.iterate
        if (player.mo and player.valid)
			if (player.mo.skin == "s3sonic")
				
				player.s3musicversion = cv_s3musicversion.value
				player.s3music = cv_s3music.value
				
				player.juhold = $ or 0
				player.s3launch = $ or 0
				player.mo.crouch = $ or 0
				player.charge = $ or 0
				player.sprung = $ or 0
				player.steamed = $ or 0
				player.carted = $ or 0
				player.supered = $ or 0
				player.supersound = $ or 0
				player.strotate = $ or 0
				player.stbounce = $ or 0
				player.strotang = $ or 0
				player.stroll = $ or 0
				player.strollang = $ or 0
				player.s3look = $ or 0
				player.s3oldaim = $ or 0
				player.s3curmus = $ or S_MusicName(player)
				player.s3victory = $ or 0
				player.s3rollangle = $ or 0

				player.strotang = ($ + 2)%360
				player.strollang = $ + 1
				player.steamed = max($ - 1, 0)
				
				if (player.playerstate == PST_DEAD) or P_PlayerInPain(player)
					player.mo.crouch = 0
					player.charge = 0
					player.strotate = 0
					player.supered = 0
				end

				if (CBW_Battle != nil)
					player.charflags = $ & ~SF_NOSHIELDABILITY
				else
					player.charflags = $|SF_NOSHIELDABILITY
				end
				
				if not (player.mo.crouch == 0) and (player.mo.state == S_PLAY_GASP)
					player.mo.crouch = 0
				end

				if (player.speed < FRACUNIT)
				and (player.exiting)
					player.s3victory = $ + 1
				end

				if (player.s3victory > 0)
				and (player.exiting)
				and ((player.mo.state == S_PLAY_STND) or (player.mo.state == S_PLAY_WAIT) or (player.mo.state == S_PLAY_EDGE))
					player.mo.state = S_STVICT1
				end
				
				if (player.pflags & PF_STARTDASH) and not player.powers[pw_carry] and not (player.mo.crouch == 2)
					player.pflags = $ & ~PF_STARTDASH
					S_StopSoundByID(player.mo, sfx_spndsh)
					player.mo.state = S_STCROUCH1
					player.mo.crouch = 1
				end
				
				if (player.speed <= 6*FRACUNIT) and not (player.pflags & PF_SPINNING)
					player.charability2 = 0
					if (player.cmd.buttons & BT_SPIN) and (player.mo.crouch == 0) and (player.stbounce == 0) and P_IsObjectOnGround(player.mo) and not (player.pflags & PF_SPINNING) and not (player.pflags & PF_SLIDING) and not (player.mo.state == S_PLAY_GASP) and not player.powers[pw_nocontrol] and not player.powers[pw_carry] and not (player.playerstate == PST_DEAD) and not P_PlayerInPain(player)
						player.mo.state = S_STCROUCH1
						player.mo.crouch = 1
					end
				end
				
				if (player.speed > 6*FRACUNIT) or not P_IsObjectOnGround(player.mo)
					player.charability2 = 1
				end

				if (player.mo.state == S_STKICK) 
					player.pflags = $|PF_JUMPED
					player.powers[pw_nocontrol] = 2
					if (leveltime % 4 == 0)
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.colorized = true
						ghost.scale = player.mo.scale
					end
				end
				
				if not (player.cmd.buttons & BT_SPIN) and (player.mo.crouch == 1)
					player.mo.crouch = 0
					if (player.speed <= FRACUNIT)
						player.mo.state = S_PLAY_STND
					elseif (player.speed >= FRACUNIT)
						player.mo.state = S_PLAY_WALK
					end
				end
				
				if (player.mo.crouch == 1)
					player.powers[pw_nocontrol] = 2
					if not P_IsObjectOnGround(player.mo)
						player.mo.state = S_PLAY_STND
						player.mo.crouch = 0
					end
					if not (player.mo.state == S_STCROUCH1 or player.mo.state == S_STCROUCH2)
						player.mo.state = S_STCROUCH1
					end
					if (player.cmd.buttons & BT_JUMP) and (player.juhold == 0) and (player.exiting == 0) and P_IsObjectOnGround(player.mo)
						player.mo.momx = player.cmomx
						player.mo.momy = player.cmomy
						player.pflags = $|PF_SPINNING
						player.pflags = $|PF_STARTDASH
						player.mo.state = S_PLAY_SPINDASH
						player.mo.crouch = 2
						player.powers[pw_nocontrol] = 0
					end
				end
				
				local dashspeed
				if player.powers[pw_super]
					dashspeed = player.normalspeed/FRACUNIT
				else
					dashspeed = player.normalspeed/FRACUNIT/2
				end
				
				if (player.mo.crouch == 2)
					player.pflags = $|PF_SPINNING
					player.pflags = $|PF_STARTDASH
					player.mo.state = S_PLAY_SPINDASH
					if not (player.cmd.buttons & BT_SPIN) and not (player.cmd.forwardmove < -20 and player.mo.flags2 & MF2_TWOD) and P_IsObjectOnGround(player.mo)
						player.pflags = $ & ~PF_STARTDASH
						player.mo.crouch = 0
						player.mo.state = S_PLAY_ROLL
						S_StartSound(player.mo, sfx_zoom)
						P_InstaThrust(player.mo, player.mo.angle, dashspeed*player.mo.scale + (3*player.charge)*player.mo.scale)
					end
					if not (player.exiting == 0)
						player.mo.crouch = 1
					end
				end

				//failsafe
				if (player.mo.state == S_PLAY_SPINDASH)
				and (player.speed > 4*FRACUNIT)
					player.mo.state = S_PLAY_ROLL
					player.mo.crouch = 0
					player.pflags = $ & ~PF_STARTDASH
				end

				if (player.mo.state == S_PLAY_SPINDASH)
					if not P_IsObjectOnGround(player.mo)
					or (player.powers[pw_carry] != CR_NONE)
						player.mo.crouch = 0
						player.pflags = $ & ~PF_STARTDASH
						player.pflags = $ & ~PF_SPINNING
						player.pflags = $|PF_JUMPED
						player.mo.state = S_PLAY_ROLL
					end
					if (CBW_Battle != nil)
						if (player.guard == 1)
							player.mo.crouch = 0
							player.pflags = $ & ~PF_STARTDASH
							player.pflags = $ & ~PF_SPINNING
							player.pflags = $|PF_JUMPED
							player.mo.state = S_PLAY_ROLL
						end
					end
				end
				
				local sfxCharge = {sfx_s3kab, sfx_s3kab1, sfx_s3kab2, sfx_s3kab3, sfx_s3kab4, sfx_s3kab5, sfx_s3kab6, sfx_s3kab7, sfx_s3kab8, sfx_s3kab9, sfx_s3kaba, sfx_s3kabb, sfx_s3kabc, sfx_s3kabd, sfx_s3kabe, sfx_s3kabf}
				
				if (player.mo.crouch == 2) and P_IsObjectOnGround(player.mo)
					if (player.cmd.buttons & BT_JUMP) and (player.juhold == 0)
						S_StopSoundByID(player.mo, sfxCharge[max(1, abs(player.charge - 1))])
						S_StartSound(player.mo, sfxCharge[player.charge])
						if (player.charge < 16)
							player.charge = $ + 1
						end
					end
				end
				
				if not (player.mo.crouch == 2)
					player.charge = 1
					player.stdust = 0
				end
				
				--i looky uppy
				
				if (player.cmd.buttons & BT_CUSTOM1) and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_WAIT)
				and P_IsObjectOnGround(player.mo) and not player.powers[pw_nocontrol]
					player.mo.state = S_STLOOK1
				end
				
				if (player.mo.state == S_STLOOK1 or player.mo.state == S_STLOOK2)
				and P_IsObjectOnGround(player.mo) and not player.powers[pw_nocontrol]
					if (player.speed > 0)
						player.mo.state = S_PLAY_WALK
					else
						if not (player.cmd.buttons & BT_CUSTOM1)
							player.mo.state = S_PLAY_STND
						end
					end
				end
				
				--state animation stuff
				
				if player.powers[pw_super] and (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state >= S_PLAY_SUPER_TRANS6)
					player.supered = 1
				end
				
				if (player.supered == 1) 
					if not P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_FALL)
						player.mo.state = S_PLAY_WALK
						player.supered = 0
					elseif P_IsObjectOnGround(player.mo)
						player.supered = 0
					end
				end
				
				if (player.mo.eflags & MFE_SPRUNG) and (player.steamed == 0)
					player.sprung = 1
				end
				
				if (player.sprung == 1) and not player.powers[pw_carry]
					if (player.mo.state == S_PLAY_FALL)
						player.mo.state = S_PLAY_WALK
						player.sprung = 0
					end
					if not (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
						player.sprung = 0
					end
				end
				
				if (player.mo.state == S_PLAY_FALL) and (player.strotate == 0) and (player.carted == 0) and not player.powers[pw_carry]
					player.strotate = 1
					player.strotang = (player.drawangle/ANG10) - ANG10
				end
				
				if (player.strotate == 1)
					player.drawangle = player.strotang*ANG10
					if not (player.mo.state == S_PLAY_FALL)
						player.strotate = 0
					end
				end
				
				if (player.powers[pw_carry] == CR_PTERABYTE)
					player.mo.state = S_PLAY_GLIDE
				end
				
				if (player.powers[pw_carry] == CR_MINECART) and (player.carted == 0)
					player.carted = 1
				elseif not (player.powers[pw_carry] == CR_MINECART) and (player.carted == 1)
					if (player.mo.state == S_PLAY_FALL)
						player.mo.state = S_PLAY_PAIN
					end
					player.carted = 0
				end
				
				if (player.powers[pw_shield] == SH_ELEMENTAL and player.pflags & PF_SHIELDABILITY)
					player.stbounce = 1
				end
				
				if (player.stbounce == 1) and not (player.pflags & PF_SHIELDABILITY)
					player.stbounce = 0
					player.sprung = 1
				end
				
				if (player.stroll == 1)
					if (player.s3choppy == 0)
						player.mo.rollangle = player.strollang*ANG10
					else
						player.mo.rollangle = (player.strollang/3)*ANG30
					end
					if not (player.mo.state == S_PLAY_WALK) or P_IsObjectOnGround(player.mo) 
						player.stroll = 0
						player.mo.rollangle = 0
					end
				end
				
				if (player.stroll == 1) and (player.strollang >= 36)
					player.strollang = 0
					if (player.mo.momz <= 0) and not (player.mo.eflags & MFE_VERTICALFLIP)
					or (player.mo.momz >= 0) and  (player.mo.eflags & MFE_VERTICALFLIP)
						player.stroll = 0
						player.mo.rollangle = 0
					end
				end
				
				if (player.mo.state == S_STCROUCH1 or player.mo.state == S_STCROUCH2)
				and (player.mo.crouch == 0) and P_IsObjectOnGround(player.mo)
					if (player.speed <= FRACUNIT)
						player.mo.state = S_PLAY_STND
					elseif (player.speed >= FRACUNIT)
						player.mo.state = S_PLAY_WALK
					end
				end
				
				if (player.mo.state == S_PLAY_WAIT) and (player.mo.anim_duration > 10)
					player.mo.anim_duration = 10
				end

				if (player.mo.state == S_STCROUCH2)
					player.s3look = $ - 1
				elseif (player.mo.state == S_STLOOK2)
					player.s3look = $ + 1
				else
					player.s3look = 0
				end

				if (abs(player.s3look) >= 2*TICRATE)
					if (player.s3oldaim == 0)
						player.s3oldaim = player.s3look/abs(player.s3look)*ANG10*2
						if (player.s3camera == 1) or (player.s3camera == 3)
							player.aiming = $ + player.s3oldaim
						end
					end
					if (player.s3camera != nil)
						if (player.s3camera >= 2)
							player.camerascale = FRACUNIT+(min((abs(player.s3look*2)-192),TICRATE)*FRACUNIT)/70
						else
							player.camerascale = FRACUNIT
						end
					end
				else
					if (player.s3oldaim != 0)
						if (player.s3camera == 1) or (player.s3camera == 3)
							player.aiming = $ - player.s3oldaim
						end
						player.s3oldaim = 0
					end
					player.camerascale = FRACUNIT
				end
				
				--done
				
				--thank you golden (not shine) for rewriting the music code

				-- why didn't it use MusicChange before?
				
				/*
				local s3curmusic = S_MusicName(player)
				local s3correctmusic, s3wrongmusic = s3curmusic, s3curmusic
				
				local s3musicversion = { "s3invc" , "s3supr" }
				local s3correctsupermusic = s3musicversion[player.s3musicversion]
				local otherindex = (player.s3musicversion & 1) + 1
				local s3wrongsupermusic = s3musicversion[otherindex]
				
				if player.powers[pw_super] then
					s3correctmusic = s3correctsupermusic
					s3wrongmusic = "_super"
				elseif player.powers[pw_invulnerability] then
					s3correctmusic = "s3invc"
					s3wrongmusic = "_inv"
				elseif player.powers[pw_sneakers] then
					s3correctmusic = "s3sped"
					s3wrongmusic = "_shoes"
				end
				
				if (player.s3music == 0)
					s3correctmusic, s3wrongmusic = s3wrongmusic, s3correctmusic
				end
				
				if s3curmusic ~= s3correctmusic 
				and (s3curmusic == s3wrongmusic or s3curmusic == s3wrongsupermusic) then
					//why does this bug exist
					if (player.pflags & PF_FINISHED)
						S_ChangeMusic(mapheaderinfo[gamemap].musname, true, player)
					else
						S_ChangeMusic(s3correctmusic, true, player)
					end
				end

				*/
				
				--no more music
				
				-- super
				
				if player.powers[pw_super]
					player.powers[pw_invulnerability] = 0
					
					if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_FLOAT) and (player.speed > player.runspeed - player.runspeed/4)
						player.mo.state = S_PLAY_WALK
					end
					
					if (player.mo.state == S_PLAY_STND) and (player.mo.anim_duration > 4)
						player.mo.anim_duration = 4
					end
					if P_IsObjectOnGround(player.mo)
						player.thrustfactor = 7
					else
						player.thrustfactor = 10
					end
				else
					player.thrustfactor = 5
					if (player.powers[pw_sneakers])
						if P_IsObjectOnGround(player.mo)
							player.thrustfactor = 7
						else
							player.thrustfactor = 10
						end
					end
				end
				
				if not player.powers[pw_super] and (player.charflags & SF_SUPER)
					player.charflags = $ & ~SF_SUPER
				end
				
				if player.powers[pw_super] and (player.supersound == 0)
					player.supersound = 1
					S_StartSound(player.mo, sfx_s3k46)
				elseif not player.powers[pw_super] and (player.supersound == 1)
					player.supersound = 0
				end
				
				-- no more super
				
				if (player.cmd.buttons & BT_JUMP) and (player.juhold == 0)
					player.juhold = 1
				elseif not (player.cmd.buttons & BT_JUMP) and (player.juhold == 1)
					player.juhold = 0
				end
            else
				if (player.powers[pw_sneakers])
				and S_MusicName(player) == "s3sped"
					S_ChangeMusic("_shoes",true,player)
				end

				if (player.powers[pw_super])
				and S_MusicName(player) == "s3invc"
					S_ChangeMusic("_inv",true,player)
				end

				if (player.powers[pw_super])
				and S_MusicName(player) == "s3supr"
					S_ChangeMusic("_super",true,player)
				end
			end
        end
    end
end)

addHook("PlayerHeight", function(player)
    if (player.valid and player.mo) and (player.mo.skin == "s3sonic")
        if player.mo.crouch == 1
            return P_GetPlayerSpinHeight(player)
        end
    end
end)

addHook("PlayerCanEnterSpinGaps", function(player)
    if (player.valid and player.mo) and (player.mo.skin == "s3sonic")
        if player.mo.crouch == 1
            return P_GetPlayerSpinHeight(player)
        end
    end
end)

addHook("JumpSpecial", function(player)
    if (player.valid and player.mo) and (player.mo.skin == "s3sonic")
        if player.mo.crouch == 2
            return true
        end
    end
end)

//v1.1 music and jingle carry

local function newmusiccode(old, new)
	if not (consoleplayer and consoleplayer.valid)
		return
	end
	if (cv_s3music.string == "Off")
	or (skins[consoleplayer.skin].name != "s3sonic")
		return
	end
	local suffix = "FN"
	if (cv_s3musicversion.string == "Prototype") then suffix = "PR" end
	
	if new == "_super"
		local which = "S3INVC"
		if suffix == "PR" then which = "S3SUPR" end
		S_ChangeMusic(which, true, consoleplayer)
		return true
	end

	if not consoleplayer.powers[pw_super]
		if new == "_shoes"
			S_ChangeMusic("s3sped", false, consoleplayer)	
			return true
		elseif new == "_inv" or new == "_minv"
			S_ChangeMusic("s3invc", true, consoleplayer)
			return true
		end
	end

	if new == "_1up"
		S_ChangeMusic("S3JN"+suffix, false, consoleplayer)
		return true
	end

	if new == "_clear" or new == "_CLEAR"
		S_ChangeMusic("S3CM"+suffix, false, consoleplayer)
		return true	
	end
end

addHook("MusicChange", newmusiccode)