addHook("ThinkFrame", do
    for player in players.iterate do
        if player.mo and player.valid and player.mo.skin == "s3sonic" then
            local s3skin = skins[player.mo.skin]
            player.s3dusted = $ or 0
            player.s3maced = $ or 0
            player.s3gooped = $ or 0
            player.s3pain = $ or 0
            player.s3dead = $ or 0
            
            if player.powers[pw_carry] == CR_MACESPIN then
                player.s3maced = 2
            else
                if player.s3maced > 0 then
                    player.s3maced = $ - 1
                end
            end
            
            if player.s3maced == 1 then
                player.mo.momz = $ + $/3 - $/20
            end
            
            if player.mo.eflags & MFE_GOOWATER and player.s3gooped == 0 then
                player.mo.momz = $ - $/4
                player.s3gooped = 1
            elseif not (player.mo.eflags & MFE_GOOWATER) and player.s3gooped == 1 then
                player.s3gooped = 0
            end
            
            if P_IsObjectOnGround(player.mo) then
                player.acceleration = s3skin.acceleration
                player.runspeed = s3skin.runspeed
            else
                player.mo.movefactor = 4*FRACUNIT
                if player.mo.state == S_PLAY_RUN then
                    player.runspeed = s3skin.runspeed/4
                else
                    player.runspeed = s3skin.runspeed
                end
                if player.mo.flags2 & MF2_TWOD then
                    player.acceleration = s3skin.acceleration
                else
                    player.acceleration = s3skin.acceleration/4
                end
                if not (player.mo.eflags & MFE_GOOWATER) and not player.powers[pw_carry]
                    if player.mo.eflags & MFE_UNDERWATER or player.mo.subsector.sector.special == 12 then
                        P_SetObjectMomZ(player.mo, -1*(FRACUNIT/8), true)
                    elseif not (player.mo.eflags & MFE_UNDERWATER)
                        P_SetObjectMomZ(player.mo, -1*(FRACUNIT/4), true)
                    end
                end
            end

			//apparently checking for bouncy fofs are just a pain in the ass for some reason
			for fof in player.mo.subsector.sector.ffloors()
				if (fof.fofflags & FOF_EXISTS)
				and (fof.fofflags & FOF_BOUNCY) 
				and (GetSecSpecial(fof.master.frontsector.special, 1) != 15)
					if (player.mo.z - player.mo.height <= fof.topheight + player.mo.momz)
						player.mo.momz = $ + $/3 - $/10
						//print("boing")
					end
				end
			end
            
            if player.powers[pw_justlaunched] and not (player.pflags & PF_JUMPED) then
                player.mo.momz = $ + $/3 - $/20
            end

			if (player.mo.eflags & MFE_SPRUNG)
				player.mo.momz = $ + $/3 - $/10
				if (player.s3launch == 1) 
					//print("yeah")
					player.mo.momx = $ + $/3 - $/8
					player.mo.momy = $ + $/3 - $/8
				end
				player.s3launch = 0
			end
            
            if player.powers[pw_carry] == CR_DUSTDEVIL and player.s3dusted == 0 then
                player.s3dusted = 1
            elseif not (player.powers[pw_carry] == CR_DUSTDEVIL) and player.s3dusted == 1 then
                player.mo.momz = (($ + $/3 - $/20)/FRACUNIT)*player.mo.scale
                player.s3dusted = 0
            end
            
            if P_PlayerInPain(player) and player.s3pain == 0 then
                player.mo.momz = $ + $/3 - $/20
                player.s3pain = 1
            elseif not P_PlayerInPain(player) and player.s3pain == 1 then
                player.s3pain = 0
            end
            
            if player.playerstate == PST_DEAD and player.s3dead == 0 then
                player.mo.momz = $ + $/3 -$/20
                player.s3dead = 1
            elseif not (player.playerstate == PST_DEAD) and player.s3dead == 1 then
                player.s3dead = 0
            end
            
        end
    end
end)

//they actually do
local function SpringsNeedToStopSucking(mo, spring)
     if mo.valid and mo.player and mo.skin == "s3sonic" then
        if (mo.z+mo.height > spring.z)
        and (mo.z < spring.z+spring.height)
        and (spring.flags & MF_SPRING)
		and (mobjinfo[spring.type].damage != 0)
			mo.player.s3launch = 1
        end
    end
end

addHook("MobjMoveCollide", SpringsNeedToStopSucking, MT_PLAYER)
addHook("MobjCollide", SpringsNeedToStopSucking, MT_PLAYER)


addHook("MobjThinker", function(dust)
    for player in players.iterate do
        if not player.mo.skin == "s3sonic" then return end
        if R_PointToDist2(player.mo.x,player.mo.y,dust.x,dust.y) <= dust.radius then
            if not (player.mo.z-player.mo.scale > dust.z+dust.height+FRACUNIT) and not (dust.z-player.mo.scale > player.mo.z+player.mo.height+FRACUNIT) then --yup its from instashield
                player.s3dusted = 1
            end
        end
    end
end, MT_DUSTDEVIL)